<h2>Validaciones reactivas</h2>
<hr>

<div class="row">
    <div class="col">
        <form autocomplete="off" [formGroup]="miForm" (ngSubmit)="crear()">
            <!-- nombre -->
            <div class="row mb-3">
                <label class="col-sm-3 col-form-label">Nombre</label>
                <div class="col-sm-9">
                    <input type="text" class="form-control" formControlName="nombre" placeholder="Nombre del usuario">
                    <span class="form-text text-danger" *ngIf="campoNoValido('nombre')">Debe de ser en formato de nombre y apellido</span>
                </div>
            </div>
            <!-- email -->
            <div class="row mb-3">
                <label class="col-sm-3 col-form-label">Email</label>
                <div class="col-sm-9">
                    <input type="email" class="form-control" formControlName="email" placeholder="Email del usuario">
                    <span class="form-text text-danger">{{emailMsgError}}</span>
                    <!-- <span class="form-text text-danger" *ngIf="emailRequired()">El email es obligatorio</span>
                    <span class="form-text text-danger" *ngIf="emailFormat()">El formato del email no es correcto</span>
                    <span class="form-text text-danger" *ngIf="emailExiste()">El email existe</span> -->
                </div>
            </div>
            <!-- user name -->
            <div class="row mb-3">
            <label class="col-sm-3 col-form-label">Username</label>
            <div class="col-sm-9">
                <input type="text" class="form-control" formControlName="username" placeholder="Username del usuario">
                <span class="form-text text-danger" *ngIf="campoNoValido('username')">El username no puede ser strider</span>
            </div>
            </div>
            <!-- password -->
            <div class="row mb-3">
                <label class="col-sm-3 col-form-label">Password</label>
                <div class="col-sm-9">
                    <input type="password" class="form-control" placeholder="Password del usuario" formControlName="password">
                    <span class="form-text text-danger" *ngIf="campoNoValido('password')">El password debe ser mayor de 6 caracteres</span>
                </div>
            </div>
            <!-- password -->
            <div class="row mb-3">
                <label class="col-sm-3 col-form-label">Confirmar</label>
                <div class="col-sm-9">
                    <input type="password" class="form-control" placeholder="Confirmar password" formControlName="confPassword">
                    <span class="form-text text-danger" *ngIf="campoNoValido('confPassword')">La contraseña no es igual</span>
                </div>
            </div>
            <div class="row">
                <div class="col">
                    <button class="btn btn-primary float-end" [disabled]="miForm.pending" type="submit">Crear</button>
                </div>
            </div>
        </form>
    </div>
</div>

<h5>Valid</h5>
<pre>{{ miForm.valid }}</pre>

<h5>Status</h5>
<pre>{{ miForm.status }}</pre>

<h5>Pending</h5>
<pre>{{ miForm.pending }}</pre>

<h5>Value del formulario</h5>
<pre>{{ miForm.value | json }}</pre>

<h5>Form Errors</h5>
<pre>{{ miForm.errors | json }}</pre>

<h5>Nombre</h5>
<pre>{{ miForm.controls['nombre'].errors | json }}</pre>

<h5>Email</h5>
<pre>{{ miForm.controls['email'].errors | json }}</pre>

<h5>Username</h5>
<pre>{{ miForm.controls['username'].errors | json }}</pre>

<!-- <h6>:valid</h6>
<pre>{{ miForm.controls['nombre'].valid | json }}</pre>
<h6>:touched</h6>
<pre>{{ miForm.controls['nombre'].touched | json }}</pre> -->
